=== modified file 'mysql-test/suite/pbxt/r/lowercase_view.result'
--- mysql-test/suite/pbxt/r/lowercase_view.result	2009-04-02 20:36:52 +0000
+++ mysql-test/suite/pbxt/r/lowercase_view.result	2009-08-31 11:07:44 +0000
@@ -119,7 +119,7 @@ create table t1Aa (col1 int);
 create view v1Aa as select col1 from t1Aa as AaA;
 show create view v1AA;
 View	Create View	character_set_client	collation_connection
-v1aa	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1aa` AS select `AaA`.`col1` AS `col1` from `t1aa` `AaA`	latin1	latin1_swedish_ci
+v1aa	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1aa` AS select `aaa`.`col1` AS `col1` from `t1aa` `aaa`	latin1	latin1_swedish_ci
 drop view v1AA;
 select Aaa.col1 from t1Aa as AaA;
 col1
@@ -128,7 +128,7 @@ drop view v1AA;
 create view v1Aa as select AaA.col1 from t1Aa as AaA;
 show create view v1AA;
 View	Create View	character_set_client	collation_connection
-v1aa	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1aa` AS select `AaA`.`col1` AS `col1` from `t1aa` `AaA`	latin1	latin1_swedish_ci
+v1aa	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1aa` AS select `aaa`.`col1` AS `col1` from `t1aa` `aaa`	latin1	latin1_swedish_ci
 drop view v1AA;
 drop table t1Aa;
 CREATE TABLE  t1 (a int, b int);
@@ -142,7 +142,7 @@ CREATE OR REPLACE VIEW v1 AS
 select X.a from t1 AS X group by X.b having (X.a = 1);
 SHOW CREATE VIEW v1;
 View	Create View	character_set_client	collation_connection
-v1	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1` AS select `X`.`a` AS `a` from `t1` `X` group by `X`.`b` having (`X`.`a` = 1)	latin1	latin1_swedish_ci
+v1	CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `v1` AS select `x`.`a` AS `a` from `t1` `x` group by `x`.`b` having (`x`.`a` = 1)	latin1	latin1_swedish_ci
 SELECT * FROM v1;
 a
 DROP VIEW v1;

=== modified file 'mysql-test/suite/pbxt/r/ps_1general.result'
--- mysql-test/suite/pbxt/r/ps_1general.result	2009-08-17 15:57:58 +0000
+++ mysql-test/suite/pbxt/r/ps_1general.result	2009-08-31 11:07:44 +0000
@@ -293,7 +293,7 @@ t2	1	t2_idx	1	b	A	0	NULL	NULL	YES	BTREE	
 prepare stmt4 from ' show table status from test like ''t2%'' ';
 execute stmt4;
 Name	Engine	Version	Row_format	Rows	Avg_row_length	Data_length	Max_data_length	Index_length	Data_free	Auto_increment	Create_time	Update_time	Check_time	Collation	Checksum	Create_options	Comment
-t2	PBXT	10	Fixed	0	29	1	#	4096	0	NULL	#	#	#	latin1_swedish_ci	NULL		
+t2	PBXT	10	Fixed	0	29	1024	#	4096	0	NULL	#	#	#	latin1_swedish_ci	NULL		
 prepare stmt4 from ' show table status from test like ''t9%'' ';
 execute stmt4;
 Name	Engine	Version	Row_format	Rows	Avg_row_length	Data_length	Max_data_length	Index_length	Data_free	Auto_increment	Create_time	Update_time	Check_time	Collation	Checksum	Create_options	Comment

=== added file 'mysql-test/suite/pbxt/t/lowercase_table_grant-master.opt'
--- mysql-test/suite/pbxt/t/lowercase_table_grant-master.opt	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/pbxt/t/lowercase_table_grant-master.opt	2009-08-31 11:07:44 +0000
@@ -0,0 +1 @@
+--lower_case_table_names

=== added file 'mysql-test/suite/pbxt/t/lowercase_table_qcache-master.opt'
--- mysql-test/suite/pbxt/t/lowercase_table_qcache-master.opt	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/pbxt/t/lowercase_table_qcache-master.opt	2009-08-31 11:07:44 +0000
@@ -0,0 +1 @@
+--lower_case_table_names

=== added file 'mysql-test/suite/pbxt/t/lowercase_view-master.opt'
--- mysql-test/suite/pbxt/t/lowercase_view-master.opt	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/pbxt/t/lowercase_view-master.opt	2009-08-31 11:07:44 +0000
@@ -0,0 +1 @@
+--lower_case_table_names=1

=== added file 'mysql-test/suite/pbxt/t/udf-master.opt'
--- mysql-test/suite/pbxt/t/udf-master.opt	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/pbxt/t/udf-master.opt	2009-08-31 11:07:44 +0000
@@ -0,0 +1 @@
+$UDF_EXAMPLE_LIB_OPT

=== modified file 'storage/pbxt/src/Makefile.am'
--- storage/pbxt/src/Makefile.am	2009-05-09 04:01:53 +0000
+++ storage/pbxt/src/Makefile.am	2009-08-31 11:07:44 +0000
@@ -19,7 +19,7 @@ noinst_HEADERS =		bsearch_xt.h cache_xt.
 						datadic_xt.h datalog_xt.h filesys_xt.h hashtab_xt.h \
 						ha_pbxt.h heap_xt.h index_xt.h linklist_xt.h \
 						memory_xt.h myxt_xt.h pthread_xt.h restart_xt.h \
-						streaming_xt.h sortedlist_xt.h strutil_xt.h \
+						pbms_enabled.h sortedlist_xt.h strutil_xt.h \
 						tabcache_xt.h table_xt.h trace_xt.h thread_xt.h \
 						util_xt.h xaction_xt.h xactlog_xt.h lock_xt.h \
 						systab_xt.h ha_xtsys.h discover_xt.h \
@@ -30,7 +30,7 @@ libpbxt_la_SOURCES =	bsearch_xt.cc cache
 						datadic_xt.cc datalog_xt.cc filesys_xt.cc hashtab_xt.cc \
 						ha_pbxt.cc heap_xt.cc index_xt.cc linklist_xt.cc \
 						memory_xt.cc myxt_xt.cc pthread_xt.cc restart_xt.cc \
-						streaming_xt.cc sortedlist_xt.cc strutil_xt.cc \
+						pbms_enabled.cc sortedlist_xt.cc strutil_xt.cc \
 						tabcache_xt.cc table_xt.cc trace_xt.cc thread_xt.cc \
 						systab_xt.cc ha_xtsys.cc discover_xt.cc \
 						util_xt.cc xaction_xt.cc xactlog_xt.cc lock_xt.cc locklist_xt.cc

=== modified file 'storage/pbxt/src/xt_config.h'
--- storage/pbxt/src/xt_config.h	2009-08-18 07:46:53 +0000
+++ storage/pbxt/src/xt_config.h	2009-08-31 11:07:44 +0000
@@ -81,7 +81,8 @@ const int max_connections = 500;
 #define DEBUG
 #endif // _DEBUG
 #else
-#define PBMS_ENABLED
+// Paul suggested to disable PBMS in MariaDB for now.
+// #define PBMS_ENABLED
 #endif
 
 #ifdef __FreeBSD__